source("multimethods2.R")
source("bandwidth.R")

corr<-function(r, bw=NULL)
{
  r=as.matrix(r)
  nvar=dim(r)[2]
  names=colnames(r)
  T=dim(r)[1]
  X=(1:T)/T
 
  if(is.null(bw))
  {#Find bandwidth by cross-validation
    bw<-bandwidth(X, r)
  }
  result<-LL.multi(X, r,X,bw, diag=F)	
  R=result$corr
  H=result$H
  dimnames(R)=list(NULL, names, names)
  dimnames(H)=list(NULL, names, names)
  
  return (list(T= T, R=R, H=H, bw=bw, MSE=result$mse))
  
}


