source("kernels.R")

LL.multi<-function(X, epsilon, x,h, diag=FALSE)
{
   N<-length(X)
   T<-length(x)
   M<-length(epsilon[1,])
   correlation=Q<-array(0,dim=c(T,M,M))
   SE<-0
   Q.star.minus<-matrix(0, M, M)

   for (i in 1:T)
   {

		X.mat3<-X-x[i]
      		
    kernel<-kernel(X.mat3,h,N=1)
		
		#Weights for the LL
    w.0<-sum(kernel) 
    w.1<-sum(kernel*X.mat3)
    w.2<-sum(kernel*(X.mat3)^2)
		den.c=w.0*w.2-w.1^2 
    weight<-kernel*(w.0-w.1*X.mat3)/den.c
		Q.hat<-matrix(0, M, M)
		index<-which(kernel!=0)
		for (j in index)
		{
			Q.hat<-Q.hat+epsilon[j,]%*%t(epsilon[j,])*weight[j]
		}
				
		if (sum (diag(Q.hat)<0)>0| sum(is.nan(Q.hat))>0)
		{	
			if (i==1)
			{
				Q[i,,]<-matrix(0, M, M)
			}	
			else
			{
				correlation[i, ,]<-correlation[i-1,,]	
				Q[i,,]<-Q[i-1,,]
			}
			next()
		}
    diag(Q.star.minus)<-1/sqrt(diag(Q.hat))

		R<-Q.star.minus%*%Q.hat%*%Q.star.minus
		epsilon.mat<-epsilon[i,]%*%t(epsilon[i,])
		hat.error=(epsilon.mat-Q.hat)
		SE<-sum ((as.vector(Q.hat[lower.tri(Q.hat,diag=diag)])-as.vector(epsilon.mat[lower.tri(epsilon.mat,diag=diag)]))^2)+SE
		correlation[i,,]<-R
		Q[i,,]<-Q.hat
           
   }
	
   return(list(corr=correlation,H=Q, mse=SE/T))
}

LL.multi.cv<-function(h,X, epsilon, diag=FALSE)
{
 
	N<-length(X)
	x=X
  M<-length(epsilon[1,])
  error<-0
	Q.star.minus<-matrix(0, M, M)

	for (i in 1:N)
  {

      epsilon2<-epsilon[-i,]
      X.mat3<-X[-i]-x[i]  
      kernel<-kernel(X.mat3, h, N=1)
			if (sum(is.nan(kernel))>0 | sum(is.infinite(kernel))>0)
				return(.Machine$double.xmax)
			Q.hat<-matrix(0, M, M)

      #Weights for the LL
  		w.0<-sum(kernel) 
  		w.1<-sum(kernel*X.mat3)
  		w.2<-sum(kernel*(X.mat3)^2)
			den.c=w.0*w.2-w.1^2 
			weight<-kernel*(w.0-w.1*X.mat3)/den.c
			index<-which(kernel!=0)

			for (p in index)
			{

				if(sum(w.2-w.1*X.mat3[p])<0) Q.hat<-Q.hat
				else
				{
					Q.hat<-Q.hat+epsilon2[p,]%*%t(epsilon2[p,])*weight[p]

				}
			}

			if (sum (diag(Q.hat)<0)>0 | w.0*w.2-w.1^2==0 | sum(is.nan(Q.hat))>0)
			{	
				return(.Machine$double.xmax)	
			}

			epsilon.mat<-epsilon[i,]%*%t(epsilon[i,])
			error<-error+
        sum((as.vector(epsilon.mat[lower.tri(epsilon.mat,diag=diag)])-as.vector(Q.hat[lower.tri(Q.hat,diag=diag)]))^2)
      
			if(is.nan(error)) return(.Machine$double.xmax)
	    
	   }

	   error=error/N

	   return(error)
}


